unit _Before;

INTERFACE

uses
  Classes, ComCtrls, Controls, Dialogs, ExtCtrls, Forms, Graphics, Math,
  StdCtrls, StrUtils, SysUtils;

type
  TForm3 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    ColorBox1: TColorBox;
    ColorBox2: TColorBox;
    ColorBox3: TColorBox;
    Edit1: TEdit;
    lb11: TLabel;
    lb12: TLabel;
    lb13: TLabel;
    lb14: TLabel;
    lb21: TLabel;
    lb22: TLabel;
    lb23: TLabel;
    lb24: TLabel;
    lb31: TLabel;
    lb32: TLabel;
    lb33: TLabel;
    lb34: TLabel;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel_01: TPanel;
    Panel_02: TPanel;
    Panel_03: TPanel;
    ScrollBar1: TScrollBar;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure ColorBox1Select(Sender: TObject);
    procedure ColorBox2Select(Sender: TObject);
    procedure ColorBox3Select(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox2MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox2Paint(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
  private
  public
  end;

var
  Form3: TForm3;

IMPLEMENTATION

uses _Main;

{$R *.dfm}

type TArrayTotal = array of record
                            bgn: Integer;  //   
                            rend: Integer;    //   
                            rtype: Byte;      //1-, 2-  3-      
                            end;
     TArrayShow = array of record
                           bgn: Integer;  //   
                           rend: Integer;    //   
                           clr: Byte;     //    myColor
                           h2: Word;         //       
                           end;

var arTotal: TArrayTotal;  //         16 ,     
    arShow: TArrayShow;    // ,    ;       bgn =  ;    arInf
    indexSelectedRange2: Integer; //   


////////////////////////////////////////////////////////////////////////////////////////////
//                     
////////////////////////////////////////////////////////////////////////////////////////////

//>   ,   ٨
//>     
function Definition_Range_Number1(y: integer): integer;
begin
  IF y<=41 THEN result:=0
  ELSE
  IF y>=34*Length(arShow)-60 THEN result:=Length(arShow)-2
  ELSE result := (y-8) div 34;
end;
function Definition_Range_Number2(y: integer): integer;
var
  i: integer;
begin
  For i:=Length(arShow)-2 downto 1 do
     if y>=arShow[i].h2
       then begin
            result:=i;
            EXIT;
            end;
  result:=0;
end;


//>        
procedure Draw_Number1(x,y,number: integer);
begin
  if bIsHex
    then Form3.PaintBox1.Canvas.TextOut(x,y,IntToHex(number,1))
    else Form3.PaintBox1.Canvas.TextOut(x,y,IntToStr(number))
end;
procedure Draw_Number2(x,y,number: integer);
begin
  if bIsHex
    then Form3.PaintBox2.Canvas.TextOut(x,y,IntToHex(number,1))
    else Form3.PaintBox2.Canvas.TextOut(x,y,IntToStr(number))
end;


//>        Ũ 
//>      
function FixStatePanelAddInf(i: Integer): Integer;
begin
  if i<=32 then result:=1
  else
  if i<=50 then result:=5
  else
  if i<=100 then result:=10
  else
  if i<=500 then result:=50
  else
  if i<=1000 then result:=100
  else
  if i<=5000 then result:=500
  else result:=1000;
end;
procedure FixStatePanel_01(imax: Integer);
var i,j: Integer;
begin
  With Form3 do
      BEGIN
      lb12.Caption:=IntToStr(imax);
      lb12.Left:=Panel_01.Width-lb12.Width-10;
      TrackBar1.Max:=imax;
      TrackBar1.TickStyle:=tsNone;
      if imax<16
        then begin
             CheckBox1.Checked:=false;
             CheckBox1.Enabled:=false;
             lb11.Enabled:=false;
             lb12.Enabled:=false;
             lb13.Enabled:=false;
             lb14.Visible:=false;
             ColorBox1.Visible:=false;
             TrackBar1.Enabled:=false;
             end
        else begin
             CheckBox1.Checked:=true;
             CheckBox1.Enabled:=true;
             lb11.Enabled:=true;
             lb12.Enabled:=true;
             lb13.Enabled:=true;
             lb14.Visible:=true;
             ColorBox1.Visible:=true;
             TrackBar1.Enabled:=true;
             TrackBar1.TickStyle:=tsManual;
             i:=FixStatePanelAddInf(imax);
             TrackBar1.PageSize:=i;
             j := i;
             While j<imax do
                  begin
                  TrackBar1.SetTick(j);
                  Inc(j,i);
                  end;
             end;
      END;
end;
procedure FixStatePanel_02(imax: Integer);
var i,j: Integer;
begin
  With Form3 do
      BEGIN
      lb22.Caption:=IntToStr(imax);
      lb22.Left:=Panel_02.Width-lb22.Width-10;
      TrackBar2.Max:=imax;
      TrackBar2.TickStyle:=tsNone;
      if imax<16
        then begin
             CheckBox2.Checked:=false;
             CheckBox2.Enabled:=false;
             lb21.Enabled:=false;
             lb22.Enabled:=false;
             lb23.Enabled:=false;
             lb24.Visible:=false;
             ColorBox2.Visible:=false;
             TrackBar2.Enabled:=false;
             end
        else begin
             CheckBox2.Checked:=true;
             CheckBox2.Enabled:=true;
             lb21.Enabled:=true;
             lb22.Enabled:=true;
             lb23.Enabled:=true;
             lb24.Visible:=true;
             ColorBox2.Visible:=true;
             TrackBar2.Enabled:=true;
             TrackBar2.TickStyle:=tsManual;
             i:=FixStatePanelAddInf(imax);
             TrackBar2.PageSize:=i;
             j := i;
             While j<imax do
                  begin
                  TrackBar2.SetTick(j);
                  Inc(j,i);
                  end;
             end;
      END;
end;
procedure FixStatePanel_03(imax: Integer);
var i,j: Integer;
begin
  With Form3 do
      BEGIN
      lb32.Caption:=IntToStr(imax);
      lb32.Left:=Panel_03.Width-lb32.Width-10;
      TrackBar3.Max:=imax;
      TrackBar3.TickStyle:=tsNone;
      if imax<16
        then begin
             CheckBox3.Checked:=false;
             CheckBox3.Enabled:=false;
             lb31.Enabled:=false;
             lb32.Enabled:=false;
             lb33.Enabled:=false;
             lb34.Visible:=false;
             ColorBox3.Visible:=false;
             TrackBar3.Enabled:=false;
             end
        else begin
             CheckBox3.Checked:=true;
             CheckBox3.Enabled:=true;
             lb31.Enabled:=true;
             lb32.Enabled:=true;
             lb33.Enabled:=true;
             lb34.Visible:=true;
             ColorBox3.Visible:=true;
             TrackBar3.Enabled:=true;
             TrackBar3.TickStyle:=tsManual;
             i:=FixStatePanelAddInf(imax);
             TrackBar3.PageSize:=i;
             j := i;
             While j<imax do
                  begin
                  TrackBar3.SetTick(j);
                  Inc(j,i);
                  end;
             end;
      END;
end;


//>   
function fSum(itype,imin: Integer): String;
var n: Integer;  // ,   
    sum: Integer;  //     
    i: Integer;
begin
  n := 0;
  sum := 0;
  For i:=0 to High(arTotal) do
     if (arTotal[i].rtype=itype) and (succ(arTotal[i].rend-arTotal[i].bgn)>=imin)
       then begin
            Inc(n);
            Inc(sum,succ(arTotal[i].rend-arTotal[i].bgn));
            end;

  Result := Format('  : %0:d d   = %0:x h'#13#13+
                   '  : %1:d'#13+
                   '   : %2:d d   = %2:x h'#13+
                   '    : %3:f%%',
                   [imin,n,sum,sum/Length(arFile)*100]);
end;


//>     
procedure Refresh_All_Diagrams;
begin
  With Form3 do
      begin
      PaintBox1.Canvas.FillRect(Rect(0,0,PaintBox1.Width,PaintBox1.Height));
      PaintBox1Paint(nil);
      PaintBox2.Canvas.FillRect(Rect(0,0,PaintBox2.Width,PaintBox2.Height));
      PaintBox2Paint(nil);
      end;
end;


//>     ,  
//>      
procedure Roll_To_Selected_Range;
begin
  With Form3.ScrollBar1 do
      If Visible
        then
            if Position>34*indexSelectedRange2
              then
                  Position:=34*indexSelectedRange2
              else
                  if Position+LargeChange<34*indexSelectedRange2+50
                    then Position:=34*indexSelectedRange2+50-LargeChange;
end;


//>    :   arTotal  
//>    arShow,    ר
procedure Total_Recalculation;
var col: array [0..3] of Byte;     //    myColor,     
    bdo: array [1..3] of Boolean;  //     
    pos: array [1..3] of Integer;  //   ,  
    i,j: Integer; //   arShow  arTotal 
    hi: Integer;  //    ,     
    r: Real;      // ,   ,   
begin
  With Form3 do
      begin
      col[0] := 0;
      col[1] := succ(ColorBox1.ItemIndex);
      col[2] := succ(ColorBox2.ItemIndex);
      col[3] := succ(ColorBox3.ItemIndex);
      bdo[1] := CheckBox1.Checked;
      bdo[2] := CheckBox2.Checked;
      bdo[3] := CheckBox3.Checked;
      pos[1] := TrackBar1.Position;
      pos[2] := TrackBar2.Position;
      pos[3] := TrackBar3.Position;
      end;
  //---------------------------------------------------
{}SetLength(arShow,Length(arTotal) shl 1 +2);   //    arTotal (   j)
{}If (arTotal=nil) or (arTotal[0].bgn<>0)       //  arShow (   i),
{}  then begin                                  //       
{}       arShow[0].bgn:=0;
{}       if arTotal=nil
{}         then arShow[0].rend:=High(arFile)
{}         else arShow[0].rend:=pred(arTotal[0].bgn);
{}       arShow[0].clr:=0;
{}       j:=0;
{}       end
{}  else begin
{}       arShow[0].bgn:=0;
{}       arShow[0].rend:=arTotal[0].rend;
{}       if bdo[arTotal[0].rtype] and (succ(arTotal[0].rend-arTotal[0].bgn)>=pos[arTotal[0].rtype])
{}         then arShow[0].clr:=col[arTotal[0].rtype]
{}         else arShow[0].clr:=0;
{}       j:=1;
{}       end;
{}
{}hi := High(arTotal);    
{}i := 1;                 
{}While j<=hi do
{}     Begin
{}     if arTotal[j].bgn>succ(arShow[pred(i)].rend)
{}       then             //   arShow         
{}            if arShow[pred(i)].clr=0
{}              then
{}                   arShow[pred(i)].rend:=pred(arTotal[j].bgn)
{}              else begin
{}                   arShow[i].bgn:=succ(arShow[pred(i)].rend);
{}                   arShow[i].rend:=pred(arTotal[j].bgn);
{}                   arShow[i].clr:=0;
{}                   Inc(i);
{}                   end
{}       else begin
{}            if bdo[arTotal[j].rtype] and (succ(arTotal[j].rend-arTotal[j].bgn)>=pos[arTotal[j].rtype])
{}              then begin       //  
{}                   arShow[i].bgn:=arTotal[j].bgn;
{}                   arShow[i].rend:=arTotal[j].rend;
{}                   arShow[i].clr:=col[arTotal[j].rtype];
{}                   Inc(i);
{}                   end
{}              else             // 
{}                   if arShow[pred(i)].clr=0
{}                     then
{}                          arShow[pred(i)].rend:=pred(arTotal[j].bgn)
{}                     else begin
{}                          arShow[i].bgn:=succ(arShow[pred(i)].rend);
{}                          arShow[i].rend:=pred(arTotal[j].bgn);
{}                          arShow[i].clr:=0;
{}                          Inc(i);
{}                          end;
{}            Inc(j);
{}            end;
{}     End;
{}
{}If arShow[pred(i)].rend<High(arFile)    //      
{}  then
{}       if arShow[pred(i)].clr=0
{}         then
{}             arShow[pred(i)].rend:=High(arFile)
{}         else begin
{}              arShow[i].bgn:=succ(arShow[pred(i)].rend);
{}              arShow[i].rend:=High(arFile);
{}              arShow[i].clr:=0;
{}              Inc(i);
{}              end;
{}
{}arShow[i].bgn := Length(arFile); //  arShow ( arInfo),       
{}arShow[i].rend := MaxInt;            //      (2)
{}arShow[i].clr := 77;                 //      (3)
{}SetLength(arShow,succ(i));
  //--------------------------------------------------
                                                          //     
  r:=Length(arFile)/(((Form3.Panel2.Height-14)div 20 )*20-1);  //r ,    1   
  arShow[0].h2 := 9;
  For i:=1 to High(arShow) do
     begin
     arShow[i].h2:=Round(arShow[i].bgn/r)+9;
     if arShow[i].h2<=arShow[pred(i)].h2          //      
       then arShow[pred(i)].h2:=pred(arShow[pred(i)].h2)
     end;

  With Form3 do
      begin
      PaintBox1.Height:=34*i-18;     //   

      If PaintBox1.Height<=Panel1.ClientHeight      //  
            then begin
                 ScrollBar1.Position:=0;
                 ScrollBar1.Visible:=false;
                 end
            else begin
                 ScrollBar1.PageSize:=1;  //          
                 ScrollBar1.Max:=pred(PaintBox1.Height);
                 ScrollBar1.LargeChange:=Panel1.ClientHeight;
                 ScrollBar1.PageSize:=ScrollBar1.LargeChange;
                 ScrollBar1.Visible:=true;
                 end;

          ScrollBar1Change(nil);   // ,            
      end;

  Refresh_All_Diagrams;
end;





////////////////////////////////////////////////////////////////////////////////////////////
//                             
////////////////////////////////////////////////////////////////////////////////////////////

//>  ٨   "     "
//>   (..    <>0)  arShow 
//>    arInf;     arInf.
procedure TForm3.Button1Click(Sender: TObject);
var ar: array of record          //,     
                 bgn: Integer;
                 cl: Byte;
                 end;
    a,i,s: Integer; //   ar, arInf  arShow 
begin
  SetLength(ar,Length(arInf)+Length(arShow)-2); //  ,      
  a:=0;
  i:=0;
  For s:=0 to Length(arShow)-2 do
     If arShow[s].clr<>0
       then begin            //   arShow  
            ar[a].bgn:=arShow[s].bgn;
            ar[a].cl:=arShow[s].clr;
            Inc(a);
            end
       else begin            // ,    arShow  ,   
            ar[a].bgn:=arShow[s].bgn;
            for i:=i to High(arInf) do
               if arInf[i].bgn>arShow[s].bgn
                 then BREAK;
            ar[a].cl:=arInf[pred(i)].cl;
            Inc(a);

            While arInf[i].bgn<=pred(arShow[succ(s)].bgn) do
                 begin
                 ar[a].bgn:=arInf[i].bgn;
                 ar[a].cl:=arInf[i].cl;
                 Inc(a);
                 Inc(i);
                 end;
            end;
  ar[a].bgn:=arShow[s].bgn;    //   ,       ,   
  ar[a].cl := arShow[s].clr;             //      (4)
  SetLength(ar,succ(a));
  //---------------------------

  SetLength(arInf,Length(ar));     //       arInf,
  i:=0;                            //    
  arInf[0].bgn:=0;
  arInf[0].cl:=ar[0].cl;
  For a:=1 to Length(ar)-2 do
     If ar[a].cl<>arInf[i].cl
       then begin
            Inc(i);
            arInf[i].bgn:=ar[a].bgn;
            arInf[i].cl:=ar[a].cl;
            end;

  Inc(i);                            //      
  arInf[i].bgn := ar[High(ar)].bgn;  // ,   
  arInf[i].cl := ar[High(ar)].cl;          //      (5)
  SetLength(arInf,succ(i));

  indexSelectedRange:=0;
  Close;
end;


//> /    , 
//> ˨  
procedure TForm3.CheckBox1Click(Sender: TObject);
begin
  If CheckBox1.Checked
    then begin
         lb11.Enabled:=true;
         lb12.Enabled:=true;
         lb13.Enabled:=true;
         lb14.Enabled:=true;
         TrackBar1.Enabled:=true;
         ColorBox1.Enabled:=true;
         end
    else begin
         lb11.Enabled:=false;
         lb12.Enabled:=false;
         lb13.Enabled:=false;
         lb14.Enabled:=false;
         TrackBar1.Enabled:=false;
         ColorBox1.Enabled:=false;
         end;
  indexSelectedRange2 := -1;
  Edit1.Text := '';
  Total_Recalculation;
end;
procedure TForm3.CheckBox2Click(Sender: TObject);
begin
  If CheckBox2.Checked
    then begin                   
         lb21.Enabled:=true;
         lb22.Enabled:=true;
         lb23.Enabled:=true;
         lb24.Enabled:=true;
         TrackBar2.Enabled:=true;
         ColorBox2.Enabled:=true;
         end
    else begin
         lb21.Enabled:=false;
         lb22.Enabled:=false;
         lb23.Enabled:=false;
         lb24.Enabled:=false;
         TrackBar2.Enabled:=false;
         ColorBox2.Enabled:=false;
         end;
  indexSelectedRange2 := -1;
  Edit1.Text := '';
  Total_Recalculation;
end;
procedure TForm3.CheckBox3Click(Sender: TObject);
begin
  If CheckBox3.Checked
    then begin
         lb31.Enabled:=true;
         lb32.Enabled:=true;
         lb33.Enabled:=true;
         lb34.Enabled:=true;
         TrackBar3.Enabled:=true;
         ColorBox3.Enabled:=true;
         end
    else begin
         lb31.Enabled:=false;
         lb32.Enabled:=false;
         lb33.Enabled:=false;
         lb34.Enabled:=false;
         TrackBar3.Enabled:=false;
         ColorBox3.Enabled:=false;
         end;
  indexSelectedRange2 := -1;
  Edit1.Text := '';
  Total_Recalculation;
end;


//>    ,   
//>    
procedure TForm3.ColorBox1Select(Sender: TObject);
begin
  Total_Recalculation;
end;
procedure TForm3.ColorBox2Select(Sender: TObject);
begin
  Total_Recalculation;
end;
procedure TForm3.ColorBox3Select(Sender: TObject);
begin
  Total_Recalculation;
end;


//>         
//>  ƨ   16 
procedure TForm3.FormActivate(Sender: TObject);
var ar1,ar2,ar3,ar4: array of record   // ,         
                  bgn: Integer;
                  rend: Integer;
                  end;
    lngArray: Integer;   // - 
    i,i1,i2,i3,i4: Integer;  //
    itemp: Integer;
    ic: Integer;      //  
    imax: Integer;    //     
    bIsWork: Boolean; //     
begin
{}lngArray := 0;   //    ,     ar1
{}ic := 1;
{}imax := 1;
{}bIsWork := false;
{}For i:=1 to High(arFile) do
{}   BEGIN
{}   if arFile[i]=arFile[pred(i)]
{}     then
{}         if bIsWork then inc(ic)
{}                    else begin
{}                         ic:=2;
{}                         itemp:=pred(i);
{}                         bIsWork:=true;
{}                         end
{}     else
{}         if bIsWork then begin
{}                         if ic>=16 then begin
{}                                        SetLength(ar1,Succ(lngArray));
{}                                        ar1[lngArray].bgn := itemp;
{}                                        ar1[lngArray].rend := pred(itemp+ic);
{}                                        Inc(lngArray);
{}                                        bIsWork:=false;
{}                                        end
{}                                   else bIsWork:=false;
{}                         if ic>imax then imax:=ic;
{}                         end;
{}   END;
{}if bIsWork then begin
{}                if ic>=16 then begin
{}                               SetLength(ar1,Succ(lngArray));
{}                               ar1[lngArray].bgn := itemp;
{}                               ar1[lngArray].rend := pred(itemp+ic);
{}                               end;
{}                if ic>imax then imax:=ic;
{}                end;
{}FixStatePanel_01(imax);
  //----------------------------------------------------------
{}lngArray := 0;          //    ,     ar2
{}ic := 1;
{}imax := 1;
{}bIsWork := false;
{}For i:=2 to High(arFile) do
{}   BEGIN
{}   if (arFile[i]=arFile[i-2]) and (arFile[i]<>arFile[pred(i)])
{}     then
{}         if bIsWork then inc(ic)
{}                    else begin
{}                         ic:=3;
{}                         itemp:=i-2;
{}                         bIsWork:=true;
{}                         end
{}     else
{}         if bIsWork then begin
{}                         if ic>=16 then begin
{}                                        SetLength(ar2,Succ(lngArray));
{}                                        ar2[lngArray].bgn := itemp;
{}                                        ar2[lngArray].rend := pred(itemp+ic);
{}                                        Inc(lngArray);
{}                                        bIsWork:=false;
{}                                        end
{}                                   else bIsWork:=false;
{}                         if ic>imax then imax:=ic;
{}                         end;
{}   END;
{}   if bIsWork then begin
{}                   if ic>=16 then begin
{}                                  SetLength(ar2,Succ(lngArray));
{}                                  ar2[lngArray].bgn := itemp;
{}                                  ar2[lngArray].rend := pred(itemp+ic);
{}                                  end;
{}                   if ic>imax then imax:=ic;
{}                   end;
{}FixStatePanel_02(imax);
  //----------------------------------------------------------
{}lngArray := 0;          //    ,     ar3
{}ic := 1;
{}imax := 1;
{}bIsWork := false;
{}For i:=1 to High(arFile) do
{}   BEGIN
{}   if arFile[i]=succ(arFile[pred(i)])
{}     then
{}         if bIsWork then inc(ic)
{}                    else begin
{}                         ic:=2;
{}                         itemp:=pred(i);
{}                         bIsWork:=true;
{}                         end
{}     else
{}         if bIsWork then begin
{}                         if ic>=16 then begin
{}                                        SetLength(ar3,Succ(lngArray));
{}                                        ar3[lngArray].bgn := itemp;
{}                                        ar3[lngArray].rend := pred(itemp+ic);
{}                                        Inc(lngArray);
{}                                        bIsWork:=false;
{}                                        end
{}                                   else bIsWork:=false;
{}                         if ic>imax then imax:=ic;
{}                         end;
{}   END;
{}   if bIsWork then begin
{}                   if ic>=16 then begin
{}                                  SetLength(ar3,Succ(lngArray));
{}                                  ar3[lngArray].bgn := itemp;
{}                                  ar3[lngArray].rend := pred(itemp+ic);
{}                                  end;
{}                   if ic>imax then imax:=ic;
{}                   end;
{}
{}
{}lngArray := 0;          //    ,     ar4
{}bIsWork := false;
{}For i:=1 to High(arFile) do
{}   BEGIN
{}   if arFile[i]=pred(arFile[pred(i)])
{}     then
{}         if bIsWork then inc(ic)
{}                    else begin
{}                         ic:=2;
{}                         itemp:=pred(i);
{}                         bIsWork:=true;
{}                         end
{}     else
{}         if bIsWork then begin
{}                         if ic>=16 then begin
{}                                        SetLength(ar4,Succ(lngArray));
{}                                        ar4[lngArray].bgn := itemp;
{}                                        ar4[lngArray].rend := pred(itemp+ic);
{}                                        Inc(lngArray);
{}                                        bIsWork:=false;
{}                                        end
{}                                   else bIsWork:=false;
{}                         if ic>imax then imax:=ic;
{}                         end;
{}   END;
{}   if bIsWork then begin
{}                   if ic>=16 then begin
{}                                  SetLength(ar4,Succ(lngArray));
{}                                  ar4[lngArray].bgn := itemp;
{}                                  ar4[lngArray].rend := pred(itemp+ic);
{}                                  end;
{}                   if ic>imax then imax:=ic;
{}                   end;
{}FixStatePanel_03(imax);
  //----------------------------------------------------------
  lngArray := Length(ar1)+Length(ar2)+Length(ar3)+Length(ar4);  //    
  SetLength(arTotal,lngArray);
  lngArray := Length(ar1);
  SetLength(ar1,Succ(lngArray));
  ar1[lngArray].bgn := MaxInt;
  lngArray := Length(ar2);
  SetLength(ar2,Succ(lngArray));
  ar2[lngArray].bgn := MaxInt;
  lngArray := Length(ar3);
  SetLength(ar3,Succ(lngArray));
  ar3[lngArray].bgn := MaxInt;
  lngArray := Length(ar4);
  SetLength(ar4,Succ(lngArray));
  ar4[lngArray].bgn := MaxInt;

  i1:=0;
  i2:=0;
  i3:=0;
  i4:=0;
  For i:=0 to High(arTotal) do
     BEGIN
     itemp := min( min(ar1[i1].bgn,ar2[i2].bgn), min(ar3[i3].bgn,ar4[i4].bgn) );
     arTotal[i].bgn := itemp;
     if itemp=ar1[i1].bgn then begin
                                 arTotal[i].rend := ar1[i1].rend;
                                 arTotal[i].rtype := 1;
                                 Inc(i1);
                                 end
     else
     if itemp=ar2[i2].bgn then begin
                                 arTotal[i].rend := ar2[i2].rend;
                                 arTotal[i].rtype := 2;
                                 Inc(i2);
                                 end
     else
     if itemp=ar3[i3].bgn then begin
                                 arTotal[i].rend := ar3[i3].rend;
                                 arTotal[i].rtype := 3;
                                 Inc(i3);
                                 end
     else   //if itemp=ar4[i4].bgn
                                 begin
                                 arTotal[i].rend := ar4[i4].rend;
                                 arTotal[i].rtype := 3;
                                 Inc(i4);
                                 end
     END;

  if TrackBar1.Enabled
    then lb13.Caption := fSum(1,TrackBar1.Position)
    else lb13.Caption:='    , '#13' ';
  if TrackBar2.Enabled
    then lb23.Caption := fSum(2,TrackBar2.Position)
    else lb23.Caption:='    , '#13' ';
  if TrackBar3.Enabled
    then lb33.Caption := fSum(3,TrackBar3.Position)
    else lb33.Caption:='    , '#13' ';
  Edit1.Text := '12    (+ 2  )';
  indexSelectedRange2 := -1;
  Total_Recalculation;
  If TrackBar1.Enabled then TrackBar1.SetFocus;  //..        
end;


//>        
procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  arTotal := nil;
  arShow := nil;
end;


//>      Ũ  
procedure TForm3.FormCreate(Sender: TObject);
var d: Integer;
begin
  d := ClientOrigin.X-Left;
  Constraints.MaxWidth := 663+d*2;
  Constraints.MinWidth := Constraints.MaxWidth;
  Constraints.MinHeight := 671+ClientOrigin.Y-Top+d;

  Panel1.Height := ClientHeight-7;  //      Windows   
  Panel2.Height := ClientHeight-7;
  Canvas.Pen.Color := clGray;  //   

  ColorBox1.AddItem('  ', TObject(myColor[1]));
  ColorBox1.AddItem('   ', TObject(myColor[2]));
  ColorBox1.AddItem('  ', TObject(myColor[3]));
  ColorBox1.AddItem(' ', TObject(myColor[4]));
  ColorBox1.AddItem('  #1', TObject(myColor[5]));
  ColorBox1.AddItem('  #2', TObject(myColor[6]));
  ColorBox1.AddItem('  #3', TObject(myColor[7]));
  ColorBox1.Enabled := true;
  ColorBox1.ItemIndex := 4;

  ColorBox2.AddItem('  ', TObject(myColor[1]));
  ColorBox2.AddItem('   ', TObject(myColor[2]));
  ColorBox2.AddItem('  ', TObject(myColor[3]));
  ColorBox2.AddItem(' ', TObject(myColor[4]));
  ColorBox2.AddItem('  #1', TObject(myColor[5]));
  ColorBox2.AddItem('  #2', TObject(myColor[6]));
  ColorBox2.AddItem('  #3', TObject(myColor[7]));
  ColorBox2.Enabled := true;
  ColorBox2.ItemIndex := 5;

  ColorBox3.AddItem('  ', TObject(myColor[1]));
  ColorBox3.AddItem('   ', TObject(myColor[2]));
  ColorBox3.AddItem('  ', TObject(myColor[3]));
  ColorBox3.AddItem(' ', TObject(myColor[4]));
  ColorBox3.AddItem('  #1', TObject(myColor[5]));
  ColorBox3.AddItem('  #2', TObject(myColor[6]));
  ColorBox3.AddItem('  #3', TObject(myColor[7]));
  ColorBox3.Enabled := true;
  ColorBox3.ItemIndex := 6;
end;


//>   
procedure TForm3.FormKeyDown(Sender: TObject; var key: Word;
  shift: TShiftState);
begin
  If (key=ord('Q')) and (ssCtrl in shift)
    then begin
         Form1.nHexDecClick(nil);
         Total_Recalculation;
         end;
end;


//>        
procedure TForm3.FormPaint(Sender: TObject);
var x,y: Integer;
begin
  x := Edit1.Left+41;
  y := Edit1.Top+20;
  With Canvas do
      begin
      MoveTo(x,y);
      LineTo(x,y+4);
      MoveTo(x+84,y);
      LineTo(x+84,y+4);
      MoveTo(x+168,y);
      LineTo(x+168,y+4);
      end;
end;


//>    
procedure TForm3.FormResize(Sender: TObject);
begin
  if arShow<>nil then Total_Recalculation;  //  "arShow<>nil"    ()    Windows 
end;


//>     
procedure TForm3.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i: Integer;
    str: String;
begin
  i := Definition_Range_Number1(y);
  str := ShowCode(arShow[i].bgn,succ(arShow[i].rend-arShow[i].bgn),12);
  Edit1.Text := LeftStr(str,pred(Length(str) shr 1));
  indexSelectedRange2 := i;
  Refresh_All_Diagrams;
end;


//>   
procedure TForm3.PaintBox1Paint(Sender: TObject);
const LEFTSPACE = 32;
var i,h: Integer;
begin
  With PaintBox1.Canvas do
      begin
      h := 8;

      For i:=0 to Length(arShow)-2 do   // 
         begin
         Brush.Color := myColor[arShow[i].clr];    // 
         Rectangle(LEFTSPACE,h,LEFTSPACE+35,h+35);
         Brush.Color := clWhite;

         Font.Color := clMaroon;       // 
         Font.Name := 'Estrangelo Edessa';
         TextOut(LEFTSPACE-3-Length(IntToStr(succ(i)))*6,h+12,IntToStr(succ(i)));

         Font.Color := myColor[arShow[i].clr];    // 
         Font.Name := 'Courier';
         Draw_Number1(LEFTSPACE+54,h+11,succ(arShow[i].rend-arShow[i].bgn));

         Font.Color := clBlack;                         // 
         Draw_Number1(LEFTSPACE+38,h-1,arShow[i].bgn);  //   
         Draw_Number1(LEFTSPACE+38,h+22,arShow[i].rend);

         Inc(h,34);
         end;

      If indexSelectedRange2>=0
        then begin
             Pen.Color := $00CF0000;            //  
             Pen.Width := 5;
             MoveTo(7,8+34*indexSelectedRange2);
             LineTo(7,42+34*indexSelectedRange2);
             Pen.Color := clBlack;
             Pen.Width := 1;
             end;
      end;
end;


//>     
procedure TForm3.PaintBox2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i: Integer;
    str: String;
begin
  i := Definition_Range_Number2(y);
  str := ShowCode(arShow[i].bgn,succ(arShow[i].rend-arShow[i].bgn),12);
  Edit1.Text := LeftStr(str,pred(Length(str) shr 1));
  indexSelectedRange2 := i;
  Roll_To_Selected_Range;
  Refresh_All_Diagrams;
end;


//>   
procedure TForm3.PaintBox2Paint(Sender: TObject);
const LEFTSPACE = 32;
var i,j,h: Integer;
begin
  With PaintBox2.Canvas do
      begin
      Font.Color:=$00CF0000;
      If bIsHex
        then TextOut(Panel2.Width-28,1,'HEX')
        else TextOut(Panel2.Width-28,1,'DEC');

      h:=((Panel2.Height-14)div 20)*20;  //  
      //Rectangle(LEFTSPACE,8,LEFTSPACE+35,9+h);    //- ,          ,   

      For i:=0 to Length(arShow)-2 do   // 
         begin
         Brush.Color := myColor[arShow[i].clr];
         FillRect(Rect(LEFTSPACE+1,arShow[i].h2,LEFTSPACE+34,arShow[succ(i)].h2));
         Brush.Color:=clWhite;
         Font.Color:=clMaroon;
         Font.Name:='Estrangelo Edessa';
         TextOut(LEFTSPACE-3-Length(IntToStr(succ(i)))*6,(arShow[succ(i)].h2+arShow[i].h2) shr 1 -5,IntToStr(succ(i)));  // 
         Font.Color:=clBlack;
         Font.Name:='Courier';
         Draw_Number2(LEFTSPACE+38,arShow[succ(i)].h2-12,arShow[i].rend); // 
         Draw_Number2(LEFTSPACE+38,arShow[i].h2-1,arShow[i].bgn);         //   
         end;

      MoveTo(LEFTSPACE,8);LineTo(LEFTSPACE,h+8);LineTo(LEFTSPACE+34,h+8);LineTo(LEFTSPACE+34,8);LineTo(LEFTSPACE,8);
      h:=h div 20;            // 
      j:=8;
      For i:=1 to 10 do
         begin
         inc(j,h);
         MoveTo(LEFTSPACE+32,j);
         LineTo(LEFTSPACE+34,j);
         inc(j,h);
         MoveTo(LEFTSPACE+27,j);
         LineTo(LEFTSPACE+34,j);
         end;
      MoveTo(LEFTSPACE+18,8+h*10);
      LineTo(LEFTSPACE+27,8+h*10);

      If indexSelectedRange2>=0
        then begin
             Pen.Color := $00CF0000;          //  
             Pen.Width := 5;
             MoveTo(7,arShow[indexSelectedRange2].h2);
             LineTo(7,arShow[succ(indexSelectedRange2)].h2);
             Pen.Color:=clBlack;
             Pen.Width:=1;
             end;
      end;
end;


//>        PAINTBOX,
//>     
procedure TForm3.ScrollBar1Change(Sender: TObject);
begin
  With ScrollBar1 do
      begin
      if Position>succ(Max-PageSize)
        then Position:=succ(Max-PageSize);
      PaintBox1.Top:=-Position;
      end;
end;


//>     ,    
//>   
procedure TForm3.TrackBar1Change(Sender: TObject);
begin
  lb13.Caption := fSum(1,TrackBar1.Position);
  indexSelectedRange2 := -1;
  Edit1.Text := '';
  Total_Recalculation;
end;
procedure TForm3.TrackBar2Change(Sender: TObject);
begin
  lb23.Caption := fSum(2,TrackBar2.Position);
  indexSelectedRange2 := -1;
  Edit1.Text := '';
  Total_Recalculation;
end;
procedure TForm3.TrackBar3Change(Sender: TObject);
begin
  lb33.Caption := fSum(3,TrackBar3.Position);
  indexSelectedRange2 := -1;
  Edit1.Text := '';
  Total_Recalculation;
end; 

end.
