unit _Question;

INTERFACE

uses
  Classes, Controls, Dialogs, ExtCtrls, Graphics, Forms, ShellAPI, StdCtrls,
  Windows, ColorButton;

type
  TForm2 = class(TForm)
    btnEmul: TButton;
    btnSelectionEmul: TButton;
    cbAutoEmul: TCheckBox;
    ColorButton0: TColorButton;
    ColorButton1: TColorButton;
    ColorButton2: TColorButton;
    ColorButton3: TColorButton;
    ColorButton4: TColorButton;
    ColorButton5: TColorButton;
    ColorButton6: TColorButton;
    ColorButton7: TColorButton;
    GroupBox1: TGroupBox;
    lb1: TLabel;
    lb2: TLabel;
    lb3: TLabel;
    lbEmul: TLabel;
    lbFile: TLabel;
    Memo2: TMemo;
    lb4: TLabel;
    PaintBox1: TPaintBox;
    procedure btnEmulClick(Sender: TObject);
    procedure btnSelectionEmulClick(Sender: TObject);
    procedure ColorButton0Click(Sender: TObject);
    procedure ColorButton1Click(Sender: TObject);
    procedure ColorButton2Click(Sender: TObject);
    procedure ColorButton3Click(Sender: TObject);
    procedure ColorButton4Click(Sender: TObject);
    procedure ColorButton5Click(Sender: TObject);
    procedure ColorButton6Click(Sender: TObject);
    procedure ColorButton7Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
  public
  end;

var
  Form2: TForm2;

IMPLEMENTATION

uses _Main;

{$R *.dfm}

var strEmulName: string;    // ,  
    btResult: Byte;       // 

    
//>     
procedure TForm2.btnEmulClick(Sender: TObject);
begin
  if ShellExecute(Handle, nil, PChar(strEmulName), PChar(strFileName), nil, sw_Restore)<=32
    then MessageDlg('    ', mtError,[mbOk],0);
end;


//>   
procedure TForm2.btnSelectionEmulClick(Sender: TObject);
begin
  Form1.OpenDialog1.Title := '    ';
  Form1.OpenDialog1.Filter := ' |*.*|  (*.exe)|*.exe';
  Form1.OpenDialog1.FilterIndex := 2;
  if strEmulName<>'' then Form1.OpenDialog1.FileName := strEmulName;

  If Form1.OpenDialog1.Execute
    then begin
         strEmulName := Form1.OpenDialog1.FileName;
         lbEmul.Caption := strEmulName;
         btnEmul.Enabled := true;
         end;
end;


//>  ٨     
procedure TForm2.ColorButton0Click(Sender: TObject);
begin
  Close;
end;
procedure TForm2.ColorButton1Click(Sender: TObject);
begin
  btResult := 1;
  Close;
end;
procedure TForm2.ColorButton2Click(Sender: TObject);
begin
  btResult := 2;
  Close;
end;
procedure TForm2.ColorButton3Click(Sender: TObject);
begin
  btResult := 3;
  Close;
end;
procedure TForm2.ColorButton4Click(Sender: TObject);
begin
  btResult := 4;
  Close;
end;
procedure TForm2.ColorButton5Click(Sender: TObject);
begin
  btResult := 5;
  Close;
end;
procedure TForm2.ColorButton6Click(Sender: TObject);
begin
  btResult := 6;
  Close;
end;
procedure TForm2.ColorButton7Click(Sender: TObject);
begin
  btResult := 7;
  Close;
end;


//>  
procedure TForm2.FormActivate(Sender: TObject);
begin
  btResult := 0;
  if cbAutoEmul.Checked and btnEmul.Enabled
    then btnEmulClick(self);
end;


//>  .       
//>  
procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
var ar: TDiagram;
    iBegin,iEnd: Integer;
    hi: Integer;       //       
    i,j: Integer;      //      arInf  ar
begin
  If btResult=0 then EXIT;

  iBegin := Form1.EasyHex11.Value;
  iEnd := Form1.EasyHex12.Value;
  hi := High(arInf);
  SetLength(ar,hi+3);

{}  i := 0;                         //    
{}  j := 0;                         //     
{}  While arInf[i].bgn<iBegin do  //   
{}       begin
{}       ar[j] := arInf[i];
{}       Inc(j);
{}       Inc(i);
{}       end;
{}
{}  ar[j].bgn := iBegin;    //  
{}  ar[j].cl := btResult;
{}  Inc(j);
{}
{}  While (arInf[i].bgn<=succ(iEnd)) and (i<=hi) do  // ,
{}       Inc(i);                                     // 
{}  Dec(i);
{}
{}  ar[j].bgn := succ(iEnd);   //,    
{}  ar[j].cl := arInf[i].cl;
{}
{}  While i<hi do       //   
{}       begin
{}       Inc(i);
{}       Inc(j);
{}       ar[j] := arInf[i]
{}       end;
{}  hi := j;  //k =      ar
{}
{}  SetLength(arInf,succ(hi));  //  ar    arInf,    
    //-----------------------------------------------------------------
{}
{}  arInf[0] := ar[0];         //  
{}  i := 0;
{}  For j:=1 to pred(hi) do
{}     if ar[j].cl<>arInf[i].cl
{}       then begin
{}            Inc(i);
{}            arInf[i]:=ar[j];
{}            end;
{}  Inc(i);
{}  arInf[i]:=ar[hi];          //   ,        
{}  SetLength(arInf,succ(i));

  For j:=1 to i do              // ,    ;
     if arInf[j].bgn>iBegin     //       
       then Break;
  indexSelectedRange := pred(j);
end;


//>        
procedure TForm2.FormCreate(Sender: TObject);
begin
{ ColorButton0.Color := myColor[0];   //    
  ColorButton1.Color := myColor[1];   // 
  ColorButton2.Color := myColor[2];
  ColorButton3.Color := myColor[3];
  ColorButton4.Color := myColor[4];
  ColorButton5.Color := myColor[5];
  ColorButton6.Color := myColor[6];
  ColorButton7.Color := myColor[7];  }
  lb3.Caption := '32     (+ 2 ).'#13'  -   ,   -     .';
  PaintBox1.Canvas.Pen.Color := clGray;
end;


//>        
procedure TForm2.PaintBox1Paint(Sender: TObject);
var i,x: Integer;
begin
  With PaintBox1.Canvas do
      Begin
      x := 0;
      For i:=0 to 2 do
         begin
         MoveTo(x,0);
         LineTo(x,10);
         Inc(x,168);
         end;

      x := 84;
      For i:=0 to 2 do
         begin
         MoveTo(x,0);
         LineTo(x,4);
         Inc(x,168);
         end;
      End;
end;

end.
